/**
 * Copyright © CENRA (2016)
 *
 * remi.clement@espaces-naturels.fr
 * 
 * This software is a multi-platform and portable application based on 
 * the scientifical toolbox to monitor wetlands. With this toolbox it’s 
 * possible to calculate indicators «RhoMéO» to monitor quality, 
 * fonctionalities and urban and agricultural pressures of wetlands. 
 * Indicators are calculated using naturalist data entered and/or imported,
 * and geographic data downloaded from a geographic server.
 * 
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use, 
 * modify and/ or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info". 
 * 
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability. 
 * 
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or 
 * data to be ensured and,  more generally, to use and operate it in the 
 * same conditions as regards security. 
 * 
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
*/
package fr.cenra.rhomeo.protocol.p02.additional;

import fr.cenra.rhomeo.api.data.Protocol;
import fr.cenra.rhomeo.api.result.AdditionalValue;
import fr.cenra.rhomeo.api.ui.AdditionalResultSpi;
import fr.cenra.rhomeo.protocol.p02.P02;
import fr.cenra.rhomeo.protocol.p02.additional.Value;
import java.util.Collection;
import java.util.Optional;
import javafx.beans.property.SimpleIntegerProperty;
import javafx.beans.property.SimpleStringProperty;
import javafx.collections.FXCollections;
import javafx.scene.Node;
import javafx.scene.control.Label;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.layout.BorderPane;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 *
 * @author Alexis Manin (Geomatys)
 */
@Component
public class ValueTableSpi implements AdditionalResultSpi {

    @Autowired
    P02 protocol;

    @Override
    public Protocol getProtocol() {
        return protocol;
    }

    @Override
    public Optional<Node> getResultNode(Collection<AdditionalValue> values) {
        if (values == null || values.isEmpty() || !(values.iterator().next() instanceof Value))
            return Optional.empty();

        final Label label = new Label("Nombre d'observations par valeur indicatrice");
        label.getStyleClass().add("text-bold");
        return Optional.of(new BorderPane(createTable((Collection)values), label, null, null, null));
    }

    private TableView<Value> createTable(final Collection<Value> items) {
        final TableView<Value> table = new TableView<>();
        table.setColumnResizePolicy(TableView.CONSTRAINED_RESIZE_POLICY);
        table.setEditable(false);

        final TableColumn<Value, Integer> yearColumn = new TableColumn<>("Année");
        yearColumn.setCellValueFactory(param -> new SimpleIntegerProperty(param.getValue().getYear()).asObject());
        table.getColumns().add(yearColumn);

        final TableColumn<Value, String> nameColumn = new TableColumn<>("Nom");
        nameColumn.setCellValueFactory(param -> new SimpleStringProperty(param.getValue().getName()));
        table.getColumns().add(nameColumn);

        for (int i = 0; i < 11; i++) {
            final TableColumn<Value, Integer> column = new TableColumn<>(Integer.toString(i));
            final int idx = i;
            column.setCellValueFactory(param -> new SimpleIntegerProperty(param.getValue().allValues()[idx]).asObject());
            table.getColumns().add(column);
        }

        table.setItems(FXCollections.observableArrayList(items));
        return table;
    }
}
